﻿define("epi-ecf-ui/contentediting/editors/LinkEditorDndMixin", [
    //dojo
    "dojo/aspect",
    "dojo/_base/declare",
    "dojo/_base/lang",

    // EPi Framework
    "epi/shell/_ContextMixin",

    // epi-cms
    "epi-cms/core/ContentReference"
], function (
    //dojo
    aspect,
    declare,
    lang,
    // EPi Framework
    _ContextMixin,
    // epi-cms
    ContentReference) {

    return declare([_ContextMixin], {

        setupDndActions: function (dndSource, func ) {
            // summary:
            //      Sets Dnd actions.
            // 
            //  
            if (func === "checkAcceptance") {
                this.own(aspect.around(dndSource, func, lang.hitch(this, function (original) {
                    return lang.hitch(this, function (source, nodes) {
                        var items = nodes.map(function (node) {
                            return source.getItem(node.id).data.item;
                        });
                        var item = items[0];
                        //we assume _currentContext is resolved otherwise we'd need to use a deferred and it's not possible here
                        if (this._currentContext && item && ContentReference.compareIgnoreVersion(this._currentContext.id, item.contentLink)) {
                            return false;
                        }
                        return original.apply(dndSource, arguments);
                    });
                })));
            }
        }
    });
});