﻿define("epi-ecf-ui/contentediting/editors/PackageEntryCollectionEditor", [
    // dojo
    "dojo/_base/declare",
    "dojo/topic",

    // ecf-ui
    "../ModelSupport",
    "../viewmodel/EntryRelationCollectionEditorModel",
    "./LinkEditEditor",
    "./_BundleEntryCollectionEditorGrid",
    "./_GroupDefinitionEditorMixin",

    // Resources
    "epi/i18n!epi/cms/nls/commerce.contentediting.editors.packageentrycollectioneditor"
],
function (
    //dojo
    declare,
    topic,

    // ecf-ui
    ModelSupport,
    EntryRelationCollectionEditorModel,
    LinkEditEditor,
    _BundleEntryCollectionEditorGrid,
    _GroupDefinitionEditorMixin,

    // Resources
    resources
) {
    var collectionEditor = declare([_BundleEntryCollectionEditorGrid], {

        modelType: EntryRelationCollectionEditorModel,

        relationType: ModelSupport.relationType.packageEntry,

        deleteConfirmationTitle: resources.deleteconfirmation.title,

        deleteConfirmationDescription: resources.deleteconfirmation.description

    });

    return declare([LinkEditEditor, _GroupDefinitionEditorMixin], {
        resources: resources,
        gridCollectionType: collectionEditor,

        executeAction: function (actionName) {
            // summary:
            //      Called when [variants and products] link clicked
            // tags:
            //      public override

            topic.publish("/epi/layout/pinnable/tools/toggle", true);
        }
    });
});
