require({cache:{
'url:epi-ecf-ui/widget/templates/CatalogContentDetails.html':"﻿<div class=\"epi-containerLayout\">\r\n    <div data-dojo-type=\"epi/shell/layout/SimpleContainer\" data-dojo-attach-point=\"widgetContainer\"></div>\r\n    <ul>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.visibleto.title}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"visibleToNode\" class=\"dijitInline\"></span>\r\n                <div data-dojo-type=\"dijit/form/Button\" data-dojo-attach-point=\"manageAccessRightsButton\" data-dojo-attach-event=\"onClick: _onManageAccessRightsClick\" class=\"epi-chromelessButton epi-chromelessLinkButton epi-functionLink\">${resources.manage}</div>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.existinglanguages}</label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"languagesNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label>${resources.idandtypename}</label> \r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <span data-dojo-attach-point=\"idNode\" class=\"dijitInline\"></span>, <span data-dojo-attach-point=\"typeNode\" class=\"dijitInline\"></span>\r\n            </div>\r\n        </li>\r\n        <li class=\"epi-formsRow\">\r\n            <label></label>\r\n            <div class=\"epi-formsWidgetWrapper\">\r\n                <div data-dojo-attach-point=\"dropdownButton\" data-dojo-type=\"dijit/form/DropDownButton\" class=\"dijit dijitReset dijitInline epi-mediumButton\">\r\n                    <span>${resources.toolsbutton.label}</span>\r\n                    <div data-dojo-type=\"dijit/DropDownMenu\" data-dojo-attach-point=\"additionalActionsMenu\"></div>\r\n                </div>\r\n            </div>\r\n        </li>\r\n    </ul>\r\n</div>"}});
﻿define("epi-ecf-ui/widget/CatalogContentDetails", [
        "dojo",
        "dojo/_base/array",
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/_base/url",
        "dojo/_base/window",
        "dojo/aspect",
        "dojo/dom-style",
        "dojo/dom-construct",
        "dojo/when",
        "epi/shell/layout/SimpleContainer",
        "epi/shell/TypeDescriptorManager",
        "epi-cms/contentediting/ContentDetails",
        "epi-cms/core/PermanentLinkHelper",
        "dojo/text!./templates/CatalogContentDetails.html"
],
    function (
        dojo,
        array,
        declare,
        lang,
        url,
        win,
        aspect,
        domStyle,
        domConstruct,
        when,
        SimpleContainer,
        TypeDescriptorManager,
        ContentDetails,
        PermanentLinkHelper,
        template
        ) {

        return declare([ContentDetails], {
            templateString: template,

            // thumbnailToken: String
            //      Represents the thumbnail token / thumbnail size to be displayed on header as content's asset preview.
            //      This should match the LargeThumbnail property name of EPiServer.Commerce.SpecializedProperties.CommerceImage.
            //      In order to modify the thumnail size, please update EPiServer.Commerce.SpecializedProperties.CommerceImage.LargeThumbnail's ImageDescriptor, 
            //      or create a new property, and set this thumbnailToken value to that property name.
            thumbnailToken: "LargeThumbnail",

            // thumbnailNode: DOM node
            //      Represents the thumbnail node, which would be added to the header section, to display content's thumbnail.
            thumbnailNode: null,

            buildRendering: function () {
                this.inherited(arguments);

                // Escaping is tricky in the data-dojo-props JSON notation, so setting tooltip here instead.
                this.dropdownButton.set("tooltip", this.resources.toolsbutton.tooltip);
            },

            _setModelAttr: function () {
                this.inherited(arguments);

                if (this.model) {
                    this.own(this.model.watch("dataModel", lang.hitch(this, this._onDataModelChanged)));
                }
            },

            _onDataModelChanged: function () {
                // summary:
                //      On data model changed, listen for model's onPropertyEdited even, to update thumbnail image in the header.
                // tags:
                //      private

                if (this.model && this.model.dataModel) {
                    this.own(aspect.after(this.model.dataModel, "onPropertyEdited", lang.hitch(this, function (propertyName, value) {
                        if (propertyName !== "commerceMediaCollection") {
                            return;
                        }

                        this._onMediaCollectionPropertyChanged(value);
                    }), true /*receiveArguments setting this as true in order to get corrected propertyName, value arguments (which are original arguments)*/));

                    // we need to update thumbnail on first load too
                    this._onMediaCollectionPropertyChanged(this.model.dataModel.contentModel && this.model.dataModel.contentModel["epi-commerceMediaCollection"] || null);
                }
            },

            _onMediaCollectionPropertyChanged: function (value) {
                // summary:
                //      When commerceMediaCollection property value changed, get the first asset to set as content thumbnail.
                // tags:
                //      private

                if (!value || value.length < 1) {
                    this._renderThumbnail(""); // if content's asset is empty, let's set thumbnail image's source as blank.
                    return;
                }

                var firstAsset = null;
                // looking for the first image in asset list
                array.some(value, function (item) {
                    if (item && TypeDescriptorManager.isBaseTypeIdentifier(item.assetType, "episerver.core.icontentimage")) {
                        firstAsset = item;
                        return item;
                    }
                }, this);

                if (!firstAsset) {
                    this._renderThumbnail("");
                    return;
                }

                if (firstAsset.url) {
                    this._renderThumbnail(firstAsset.url);
                } else {
                    // if firstAsset.url is not ready, we need to get its public URL via PermanentLinkHelper
                    when(PermanentLinkHelper.getContent(firstAsset.assetKey), lang.hitch(this, function (content) {
                        if (!content) { // content not found
                            this._renderThumbnail("");
                        } else {
                            this._renderThumbnail(content.publicUrl);
                        }
                    }));
                }
            },

            addChild: function (w) {
                this.widgetContainer.addChild(w);
            },

            _renderThumbnail: function (imageUrl) {
                // summary:
                //      Injects the thumbnail image to the header section (if it was not added), and update its image URL.
                // tags:
                //      protected

                var parentNode = this.domNode.parentNode;
                if (!parentNode) {
                    return;
                }
                var imageSource = !imageUrl ? "" : (imageUrl + "/" + this.thumbnailToken + "?time=" + new Date().getTime()); // append time parameter to make sure image will be refresh all the time, to avoid cache issue.

                if (!this.thumbnailNode) {
                    this.thumbnailNode = domConstruct.create("img", {
                        src: imageSource,
                        className: "epi-heading-thumbnail"
                    });
                    domConstruct.place(this.thumbnailNode, parentNode, "first");
                } else {
                    this.thumbnailNode.src = imageSource;
                }

                domStyle.set(this.thumbnailNode, "display", !!imageSource ? "block" : "none");
            },

            _setExistingLanguagesAttr: function (languages) {
                this.languagesNode.innerHTML = "";

                // Create text or link elements base on language information.
                array.forEach(languages, function (item, idx) {
                    var elm, isLast = idx === languages.length - 1;
                    if (this.model.dataModel.currentContentLanguage === item.text) {
                        elm = domConstruct.create("span", {
                            innerHTML: item.urlSegment
                        });
                    } else {
                        var url = new dojo._Url(window.top.location.href);
                        elm = domConstruct.create("a", {
                            innerHTML: item.urlSegment,
                            href: [url.scheme, "://", url.authority, url.path, "?language=", item.text, "#context=epi.cms.contentdata:///", item.contentLink].join(""),
                            "class": "epi-visibleLink"
                        });
                    }
                    domConstruct.place(elm, this.languagesNode);

                    if (!isLast) {
                        domConstruct.place(win.doc.createTextNode(", "), this.languagesNode);
                    }
                }, this);
            }
        });
    });
