﻿<%@ Page Language="C#" Inherits="System.Web.Mvc.ViewPage<MigrationModel>"%>
<%@ Import Namespace="EPiServer.Commerce.UI.Models.Migrate" %>
<%@ Import Namespace="EPiServer.Commerce.Internal.Migration" %>
<%@ Import Namespace="EPiServer.Shell"%>
<%@ Import Namespace="EPiServer.Framework.Web.Resources"%>


<html>
    <head>
        <title>EPiServer Commerce Migration</title>
        <% if (Model.Status == MigrationStatus.InProgress){ %>
            <meta http-equiv="refresh" content="5" />
        <%} %>

        <%= Page.ClientResources("EPi.Shell.UI", new[] { ClientResourceType.Style }) %>
        <link rel="stylesheet" type="text/css" href="<%= Paths.ToClientResource("CMS", "ClientResources/epi-cms/epi.css") %>"></link>
        <link rel="stylesheet" type="text/css" href="<%= Paths.ToClientResource("EPiServer.Commerce.Shell", "ClientResources/epi-ecf-ui/epiCommerce.css") %>"></link>
    </head>
    <body class="Sleek">
        <div class="epi-view-container epi-view-container--scrollable">
            <h1>EPiServer Commerce Migration Steps</h1>
            <div class="dgrid epi-plain-grid epi-plain-grid-modal epi-plain-grid--margin-bottom epi-plain-grid--cell-borders">
                <table class="dgrid-row-table">
                    <tr class="dgrid-header">
                        <th class="dgrid-cell epi-grid-column--bold">Name</th>
                        <th class="dgrid-cell epi-grid-column--bold">Description</th>
                        <th class="dgrid-cell epi-grid-column--bold">Status</th>
                        <th class="dgrid-cell epi-grid-column--bold">Last Run</th>
                    </tr>
                    <% foreach (var step in Model.Steps)
                        { %>
                    <tr>
                        <td class="dgrid-cell"><%: step.Name %></td>
                        <td class="dgrid-cell"><%: step.Description %></td>
                        <td class="dgrid-cell"><span class="dijitInline dijitIcon <%: step.StatusIcon %>"></span></td>
                        <td class="dgrid-cell"><%: step.LastRun %></td>
                    </tr>
                    <%} %>
                </table>
            </div>
            <h2>This can be automated</h2>
            <div>
                <p>
                    To let the migration steps run automatically, you can add &lt;add key=&quot;AutoMigrateEPiServer&quot; value=&quot;true&quot; /&gt; 
                    to the appSettings section in web.config.
                    Next time when you update your site via nuget packages, the migration process will be run automatically.
                    If all steps run successfully, you'll be able to redirect to the home page. 
                    Otherwise errors will be displayed in migration page and will also be logged via log4net.               
                </p>
            </div>
            <h2>Backing up database</h2>
            <div>
                <p>
                    The migration steps cannot be undone. If you want to be able to roll back the changes you should take a backup of your databases (CMS and Commerce).
                </p>
            </div>
            <% if (Model.CanStartMigrationJob)
               { %>
                <% Html.BeginForm("Run", "Migrate"); %>
                    <input type="submit" class="epi-chromeless epi-visibleLink" value="Execute all remaining steps">
                <% Html.EndForm(); %>
            <% } %>
            <h2><%= Model.StatusMessage %></h2>
            <h2>Log</h2>
            <div class="half-height half-height--scrollable">
                <ul class="epi-chromeless epi-list">
                    <% foreach (var message in Model.Messages){ %>
                        <li><span class="epi-secondaryText"><%= message.ToHtmlString() %></span></li>
                    <% } %>
                </ul>
            </div>
        </div>
    </body>
</html>
